"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkMink = function (lm_id) {
    return {
        initTracking: initTracking(lm_id),
        conversion: conversion(lm_id)
    };
};
var initTracking = function (lm_id) { return function () { return __awaiter(_this, void 0, void 0, function () {
    var location, host, chunky, origin, r, m, tag, cookieValue, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                location = window.location.host;
                host = location.split('.');
                chunky = host.slice(-2);
                origin = '.' + chunky.join('.');
                checkUrl('lmref-test') ? console.error('in v3, there is no need for lmref-test. You can just use the lmref url param') : null;
                r = checkUrl('lmref') || '';
                m = checkUrl('lm_meta') || '';
                tag = isNumeric(r) ? 'aff' : 'ref';
                if (!r) return [3, 4];
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4, generateCookie(r, tag, m)];
            case 2:
                cookieValue = _a.sent();
                createCookie('lmref', cookieValue, 2160, origin);
                return [3, 4];
            case 3:
                e_1 = _a.sent();
                console.error('There seems to be a LinkMink url parameter, however a cookie was not set');
                return [3, 4];
            case 4: return [2];
        }
    });
}); }; };
function generateCookie(referrerID, tag, metadata) {
    return __awaiter(this, void 0, void 0, function () {
        var cookies, existingCookie, existingLead, referral_data, clickInfo, _a, _b, _c, _d, _e, resp, e_2, cookie;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    cookies = getCookies();
                    existingCookie = cookies.lmref;
                    try {
                        existingLead = existingCookie && !parseInt(existingCookie) ? JSON.parse(atob(existingCookie)).id : undefined;
                    }
                    catch (e) {
                        existingLead = undefined;
                    }
                    switch (tag) {
                        case 'aff':
                            referral_data = { contract_id: referrerID, tag: tag };
                            break;
                        case 'ref':
                            try {
                                referral_data = { tag: tag, customer_id: decodeReferrerID(referrerID) };
                            }
                            catch (e) {
                                referral_data = { tag: tag, customer_id: referrerID };
                                console.error('This LinkMink referral parameter is in an incorrect format');
                            }
                            break;
                        default:
                            console.error('This LinkMink parameter is in an incorrect format');
                            return [2];
                    }
                    _a = {
                        tag: 'V3'
                    };
                    _b = existingLead;
                    if (_b) return [3, 2];
                    _c = 'lead';
                    return [4, generateID()];
                case 1:
                    _b = _c + (_f.sent());
                    _f.label = 2;
                case 2:
                    _a.id = _b;
                    _d = {};
                    _e = 'click';
                    return [4, generateID()];
                case 3:
                    clickInfo = (_a.click = (_d.id = _e + (_f.sent()),
                        _d.referral_data = referral_data,
                        _d.source = document.referrer,
                        _d.destination = document.location.origin + document.location.pathname,
                        _d.metadata = metadata || null,
                        _d),
                        _a);
                    _f.label = 4;
                case 4:
                    _f.trys.push([4, 6, , 7]);
                    return [4, trackClick(clickInfo)];
                case 5:
                    resp = _f.sent();
                    return [3, 7];
                case 6:
                    e_2 = _f.sent();
                    return [3, 7];
                case 7:
                    cookie = btoa(JSON.stringify(clickInfo));
                    return [2, cookie];
            }
        });
    });
}
function isNumeric(n) {
    var a = parseFloat(n);
    return Boolean(!isNaN(a) && isFinite(a));
}
function isBase64(str) {
    try {
        return btoa(atob(str)) == str;
    }
    catch (e) {
        return false;
    }
}
function decodeReferrerID(referrerID) {
    if (isBase64(referrerID))
        return atob(referrerID);
    else
        throw ('This is not a base64 encoded string');
}
function getCookies() {
    var cookies = document.cookie.split('; ').reduce(function (acc, v) {
        var _a = v.split('='), k = _a[0], v2 = _a[1];
        acc[k] = v2;
        return acc;
    }, {});
    return cookies;
}
function get(parameter, URL) {
    var reg = new RegExp("[?&]" + parameter + "=([^&#]*)", 'i');
    var string = reg.exec(URL);
    return string ? string[1] : undefined;
}
function checkUrl(param) {
    var url = window.location.href;
    var paramExists = get(param, url);
    return paramExists ? paramExists : undefined;
}
function createCookie(name, value, hours, origin) {
    var expires = '';
    if (hours) {
        var date = new Date();
        date.setTime(date.getTime() + (hours * 60 * 60 * 1000));
        expires = "; expires=" + date.toUTCString();
    }
    var reg = new RegExp('localhost');
    reg.exec(origin) ? document.cookie = name + "=" + value + expires + ";path=/" : document.cookie = name + "=" + value + expires + ";domain=" + origin + ";path=/";
}
function trackClick(clickInfo) {
    return __awaiter(this, void 0, void 0, function () {
        var options, req, res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    options = {
                        method: 'POST',
                        body: JSON.stringify(clickInfo)
                    };
                    req = new Request('https://app.linkmink.com:8000/api/clicks', options);
                    req.headers.set('Content-Type', 'application/json');
                    return [4, window.fetch(req)];
                case 1:
                    res = _a.sent();
                    return [2, res];
            }
        });
    });
}
function generateID() {
    return __awaiter(this, void 0, void 0, function () {
        var p1, p2, base, array, seed, id, _a, str, i;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    p1 = Math.round(Math.random() * 62);
                    p2 = Math.round(Math.random() * 62);
                    base = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'.split('');
                    base.push(base[p1]);
                    base.push(base[p2]);
                    array = new Uint8Array(80);
                    seed = crypto.getRandomValues(array);
                    _a = Uint8Array.bind;
                    return [4, crypto.subtle.digest('SHA-1', seed)];
                case 1:
                    id = new (_a.apply(Uint8Array, [void 0, _b.sent()]))();
                    str = '';
                    for (i = 0; i < id.length; i++) {
                        str += base[id[i] % base.length];
                    }
                    ;
                    return [2, '_' + str];
            }
        });
    });
}
var conversion = function (lm_id) { return function (options) {
    var cookies = getCookies();
    var lmCookie = cookies.lmref;
    if (lmCookie && isNumeric(lmCookie))
        return lmCookie;
    if (!lmCookie)
        return;
    var lmJsonCookie;
    try {
        lmJsonCookie = JSON.parse(atob(lmCookie));
    }
    catch (e) {
        console.error('On conversion, this lmref cookie isn\'t in a supported format');
    }
    if (lmJsonCookie && lmJsonCookie.tag === 'V3') {
        try {
            if (lmJsonCookie.click.referral_data.tag === 'ref') {
                lmJsonCookie.click.referral_data.coupon_id = options ? options.coupon : console.error('No coupon attached when expected.');
            }
            return btoa(JSON.stringify(lmJsonCookie));
        }
        catch (e) {
            console.error('This LinkMink referral data was expected to be in v3 format but wasn\'t');
        }
    }
    return lmCookie;
}; };
