"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LMElements = function (lm_id) {
    return {
        loadWidget: load(lm_id),
        generateReferralLink: generateReferralLink(lm_id)
    };
};
var generateReferralLink = function (lm_user_id) { return function (stripe_cust_id, base_url) {
    var uniqueParam = generateUniqueParam(stripe_cust_id);
    var referralLink = base_url + "?lmref=" + uniqueParam;
    return referralLink;
}; };
var generateUniqueParam = function (stripe_cust_id) { return __awaiter(_this, void 0, void 0, function () {
    var referralInfo, base64EncodedParam;
    return __generator(this, function (_a) {
        referralInfo = "" + stripe_cust_id;
        base64EncodedParam = btoa(referralInfo);
        return [2, base64EncodedParam];
    });
}); };
var copyToClipboard = function (val, elem) {
    var selBox = document.createElement('textarea');
    selBox.style.position = 'fixed';
    selBox.style.left = '0';
    selBox.style.top = '0';
    selBox.style.opacity = '0';
    selBox.value = val;
    document.body.appendChild(selBox);
    selBox.focus();
    selBox.select();
    document.execCommand('copy');
    document.body.removeChild(selBox);
    elem.innerText = 'Copied';
    setTimeout(function () { elem.innerText = 'Copy'; }, 3000);
};
var open = function (e, elem) {
    elem.classList.add('open');
    e.stopPropagation();
    window.addEventListener('click', function (e) { handleOutsideClick(e, elem); }, { once: true });
};
var handleOutsideClick = function (e, elem) {
    if (!elem.contains(e.target)) {
        close(e, elem);
    }
    else {
        window.addEventListener('click', function (e) { handleOutsideClick(e, elem); }, { once: true });
    }
};
var close = function (e, elem) {
    elem.classList.remove('open');
};
var toggle = function (e) {
    var referralBody = document.getElementById('lm_referral_body');
    referralBody ? referralBody.classList.contains('open') ? close(e, referralBody) : open(e, referralBody) : console.error('No toggle element');
};
var load = function (lm_id) { return function (link, title, offer) {
    var referralHtml = "\n    <div class=\"lm-referral-container\">\n      <div class=\"lm-referral-body\" id=\"lm_referral_body\">\n        <h1 class=\"lm-heading\">" + title + "</h1>\n        <h2 class=\"lm-offer\">" + offer + "</h2>\n        <div class=\"lm-img-container\">\n          <svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 152.704 110.836\"><defs><style>.a{fill:#f2f2f2;}.b{fill:#2f2e41;}.c{fill:#ffb9b9;}.d{opacity:0.1;}.e{fill:#575a89;}.f,.h{opacity:0.2;}.g{fill:#6c63ff;}.h,.i{fill:none;stroke-miterlimit:10;stroke-width:2px;}.h{stroke:#000;}.i{stroke:#3f3d56;}.j{fill:#3f3d56;}.k{fill:#9f616a;}.l{fill:#d0cde1;}.m{fill:#57b894;}</style></defs><circle class=\"a\" cx=\"51.828\" cy=\"51.828\" r=\"51.828\" transform=\"translate(13.617 0)\"/><ellipse class=\"a\" cx=\"20.564\" cy=\"3.29\" rx=\"20.564\" ry=\"3.29\" transform=\"translate(0 104.255)\"/><ellipse class=\"a\" cx=\"31.819\" cy=\"5.091\" rx=\"31.819\" ry=\"5.091\" transform=\"translate(89.066 97.309)\"/><path class=\"b\" d=\"M853.394,435.945s.271.9-1.264,1.716-1.987,3.883-.181,4.786,2.348,2.077,1.445,2.89-2.528,2.98-.361,3.522,2.438,1.625,1.806,2.077,1.445-.813,1.445-.813.361,2.167,2.258,1.625,7.224-10.836,4.515-12.281A78.086,78.086,0,0,0,853.394,435.945Z\" transform=\"translate(-739.579 -382.48)\"/><path class=\"c\" d=\"M871.408,490.657s.937,3.278-.7,3.513a6.4,6.4,0,0,0-2.81,1.171l3.044,3.981h5.62l3.513-3.513s-4.683-3.513-3.747-5.62S871.408,490.657,871.408,490.657Z\" transform=\"translate(-754.32 -428.473)\"/><path class=\"d\" d=\"M871.408,490.657s.937,3.278-.7,3.513a6.4,6.4,0,0,0-2.81,1.171l3.044,3.981h5.62l3.513-3.513s-4.683-3.513-3.747-5.62S871.408,490.657,871.408,490.657Z\" transform=\"translate(-754.32 -428.473)\"/><path class=\"c\" d=\"M852.787,719.36l5.386,1.873,3.747.234-.234-3.278-7.728-2.285Z\" transform=\"translate(-734.294 -616.431)\"/><path class=\"e\" d=\"M953,767.605s0,3.278.468,3.278,6.791-.7,8.664,0,4.683-1.873,3.278-3.278-3.7-3.513-5.127-3.044S953,766.2,953,766.2Z\" transform=\"translate(-827.602 -665.378)\"/><path class=\"e\" d=\"M819.339,764.974s-2.81,5.62-.937,6.088a6.5,6.5,0,0,0,4.215-.468c.234-.234,3.513-1.171,3.981-.7s.468-1.873.468-1.873Z\" transform=\"translate(-711.149 -665.791)\"/><path class=\"b\" d=\"M831.263,709.359s-4.449,6.088-1.171,7.728,18.968,1.639,20.138,0,1.639-6.791,0-7.259S831.263,709.359,831.263,709.359Z\" transform=\"translate(-720.732 -617.904)\"/><path class=\"f\" d=\"M831.263,709.359s-4.449,6.088-1.171,7.728,18.968,1.639,20.138,0,1.639-6.791,0-7.259S831.263,709.359,831.263,709.359Z\" transform=\"translate(-720.732 -617.904)\"/><circle class=\"c\" cx=\"5.386\" cy=\"5.386\" r=\"5.386\" transform=\"translate(113.575 53.052)\"/><path class=\"g\" d=\"M845.987,526.6l4.683-.937s1.171,3.747,4.918,3.044,4.683-3.044,4.683-3.044,2.81,1.171,3.044,1.171,3.278,1.171,3.278,1.873-3.513,7.728-3.513,7.728l.468,12.645-17.328-.468,1.171-12.411Z\" transform=\"translate(-735.456 -459.73)\"/><path class=\"c\" d=\"M822.551,576.22s-1.405,12.411-.468,13.348,4.683,3.513,4.683,3.513v-2.81l-1.873-3.513,1.873-8.2Z\" transform=\"translate(-714.596 -503.264)\"/><path class=\"c\" d=\"M972.129,573.692s-.82,12.762-.82,13.231-2.108,2.108-2.81,2.108-1.171-1.171-1.171-1.171l1.639-1.873-1.171-9.6Z\" transform=\"translate(-839.937 -501.088)\"/><path class=\"b\" d=\"M918.392,686.494s10.538-5.854,10.772,0-5.386,8.2-5.386,8.2-14.518,4.354-15.1,2.762-1.756-4.167-.82-4.4,2.108-.7,2.576-.234,6.322-3.513,6.322-3.513Z\" transform=\"translate(-788.424 -595.975)\"/><path class=\"h\" d=\"M980.626,697.562a13.322,13.322,0,0,0-2.81,1.639,18.15,18.15,0,0,1-3.747,1.873\" transform=\"translate(-845.741 -607.746)\"/><path class=\"g\" d=\"M823.629,532.871l-1.4-.468s-5.152,5.386-3.513,6.791,2.576,1.873,3.044,2.342,2.81.7,2.81.7Z\" transform=\"translate(-711.693 -465.535)\"/><path class=\"g\" d=\"M958.81,544.2l2.107.468a34.365,34.365,0,0,0,2.108,3.981c.468.468-.7.234-1.405,1.171s-1.4,2.576-2.81,2.576-3.278-2.342-3.278-2.342Z\" transform=\"translate(-829.779 -475.693)\"/><path class=\"b\" d=\"M772.993,696.922s-8.9-6.323-11.943-1.639,13.113,11.006,15.455,11.943,4.449,1.873,4.449,1.873,2.108-5.152,2.108-6.088-1.639-.937-2.108-.937-2.576-.468-3.044-1.171A52.663,52.663,0,0,0,772.993,696.922Z\" transform=\"translate(-661.993 -604.295)\"/><path class=\"h\" d=\"M813.966,705.988a13.554,13.554,0,0,0,4.449,2.342,4.353,4.353,0,0,1,2.81,1.639\" transform=\"translate(-707.884 -615.001)\"/><path class=\"e\" d=\"M837.731,634.785l.187,9.915a1.241,1.241,0,0,0,1.255,1.218l18.451-.207a1.241,1.241,0,0,0,1.225-1.17l.56-9.707a1.241,1.241,0,0,0-1.239-1.313h-19.2a1.241,1.241,0,0,0-1.241,1.265Z\" transform=\"translate(-728.346 -552.603)\"/><path class=\"b\" d=\"M890.753,423.04s.3,1-1.4,1.9-2.2,4.3-.2,5.3,2.6,2.3,1.6,3.2-2.8,3.3-.4,3.9,2.7,1.8,2,2.3,1.6-.9,1.6-.9.4,2.4,2.5,1.8,4.2-11.51,1.855-14.32C896.132,423.612,890.753,423.04,890.753,423.04Z\" transform=\"translate(-771.504 -371.368)\"/><path class=\"b\" d=\"M904.13,411.4c0-1.466,4.385-.412,6.265,1.634,1.3,1.417,3.279,3.549,1.622,5.051s2.84,3.473,4.046,4.07,3.587,2.424,1.437,3.649-2.115,2.462-1.306,2.755-1.784-.435-1.784-.435.262,2.42-1.923,2.408-8.453-12.018-6.955-15.356C906.924,412.068,904.13,411.4,904.13,411.4Z\" transform=\"translate(-785.52 -360.753)\"/><path class=\"b\" d=\"M870.983,413.193c-5.863-.353-6.452,4.06-6.452,4.06.041,2.554,4.1,1.31,5.223,1.69,1.359-.978,3.979-2.828,5.852-4.148A8.861,8.861,0,0,0,870.983,413.193Z\" transform=\"translate(-751.424 -362.872)\"/><path class=\"i\" d=\"M662.349,352.45s-5.259-24.649-38.179-42.53\" transform=\"translate(-544.459 -273.966)\"/><path class=\"j\" d=\"M573.382,254.891l.066.27-1.332.323.419,1.3-.265.085-.511-1.589Z\" transform=\"translate(-492.315 -219.474)\"/><path class=\"g\" d=\"M67.6,753.313c0,3.122-1.856,4.212-4.145,4.212l-.159,0c-.106,0-.211-.007-.315-.014-2.066-.146-3.672-1.292-3.672-4.2,0-3,3.84-6.8,4.128-7.077h0l.017-.016S67.6,750.191,67.6,753.313Z\" transform=\"translate(-58.082 -649.642)\"/><path class=\"j\" d=\"M77.727,757.047l1.516-2.119-1.52,2.351,0,.243c-.106,0-.211-.007-.315-.014l.163-3.123v-.024l0,0,.015-.295L76.061,751.7l1.529,2.136,0,.063.123-2.36-1.3-2.436,1.32,2.021.129-4.893v0l-.021,3.858,1.3-1.53-1.3,1.862-.034,2.113,1.213-2.028L77.8,752.85l-.019,1.175,1.76-2.822-1.767,3.232Z\" transform=\"translate(-72.509 -649.642)\"/><path class=\"b\" d=\"M211.389,787.368l.887-.659s.587,3.279-.068,3.77-3.111,1.31-3.111,2.292-5.567,2.292-5.731.819a3.247,3.247,0,0,1,.491-2.292s2.62-2.62,2.947-3.111,1.146-1.474,1.146-1.474Z\" transform=\"translate(-182.103 -684.506)\"/><path class=\"b\" d=\"M167,486.852s.025.144.067.408c.039.234.093.565.159.973.688,4.2,2.694,16.551,2.558,16.959-.164.491-1.31,2.292,0,2.784a1.016,1.016,0,0,1,.408.444,9.517,9.517,0,0,1,.693,1.634,71.8,71.8,0,0,1,2.1,8.4c.211,1.1.355,1.991.4,2.456a1.335,1.335,0,0,1,0,.324c-.164.655.982,2.947,1.474,3.6s1.31,1.31,1.146,1.965,4.094,2.456,4.585,1.31a20.9,20.9,0,0,0,.655-2.129c.164-.328.327-2.62-.491-2.947s-.327-6.059-1.146-7.2a15.736,15.736,0,0,1-1.128-3.227c-.172-.609-.345-1.258-.516-1.908-.691-2.664-1.3-5.345-1.3-5.345l.164-19.158-9.006-1.146-.231.509-.46,1.01Z\" transform=\"translate(-150.809 -424.762)\"/><path class=\"b\" d=\"M125.459,720.67s-1.31-1.31-1.965,0-1.31,6.386-2.456,7.532-2.62,6.877-.982,7.2,3.439-.491,3.6-1.474,3.6-6.059,3.6-6.55-2.292-2.292-2.292-2.292Z\" transform=\"translate(-109.763 -627.142)\"/><path class=\"b\" d=\"M176.222,430.411s-2.129,19.158-2.62,20.959-3.111,8.678-3.93,9.825-6.059,10.48-6.714,10.971-1.965,1.8-1.965,1.8-2.456,2.456-2.784,2.947-3.111-.982-3.275-1.965a10.1,10.1,0,0,1,.327-3.275c.164-.655-.327-1.637.164-2.129s2.947-2.947,2.947-4.094,4.257-7.86,5.895-9.333a4.884,4.884,0,0,0,1.31-3.93V442.2l-9.006-2.784s.491-7.86,1.637-7.86S174.421,428.938,176.222,430.411Z\" transform=\"translate(-140.386 -377.328)\"/><circle class=\"k\" cx=\"5.404\" cy=\"5.404\" r=\"5.404\" transform=\"translate(17.169 14.931)\"/><path class=\"k\" d=\"M181.272,210.868s.655,2.456,1.474,3.111-2.129,3.439-2.129,3.439l-5.567.327-.982-3.111s1.8-3.6,1.31-5.895S181.272,210.868,181.272,210.868Z\" transform=\"translate(-156.898 -186.277)\"/><path class=\"g\" d=\"M177.476,248.18s-1.474.164-1.8.655a5.868,5.868,0,0,1-4.421,1.637c-1.8-.328-2.947-.819-3.275-.655s-.982,3.6-.982,3.6l1.8,5.24-.327,14.41-.491,3.93s-.982-1.31,2.947-.491,9.006-.655,10.643-.819,4.421-.655,4.585-1.637a25.9,25.9,0,0,0-.491-4.585l-2.62-10.971-1.637-5.895Z\" transform=\"translate(-150.809 -220.804)\"/><path class=\"l\" d=\"M231.271,240.683s1.385-.735,1.876-.08,6.714,1.637,6.714,2.129,1.31,13.755.982,14.9a3.337,3.337,0,0,0,.655,2.456L242.644,265s3.111,9.333,1.8,9.661a8.526,8.526,0,0,1-2.947,0c-.491,0-.327-6.222-1.637-7.86a36.837,36.837,0,0,1-3.439-6.55c-.328-.819-4.421-12.117-4.257-13.427S231.271,240.683,231.271,240.683Z\" transform=\"translate(-206.153 -214.046)\"/><path class=\"l\" d=\"M139.7,248.18s-1.31,0-1.474.328a17.922,17.922,0,0,1-2.456,2.947c-.655.491-2.947,2.62-2.947,3.111s4.749,4.094,4.749,4.094,1.965,9.661.982,12.936-2.456,11.135-1.8,11.626,2.129.655,2.129,0,.982-7.7,1.8-9.17,3.275-10.807,2.292-13.427S139.7,248.18,139.7,248.18Z\" transform=\"translate(-121.383 -220.804)\"/><path class=\"k\" d=\"M265.828,364.847s.164,5.076-1.637,7.7a31.117,31.117,0,0,0-2.947,5.567s-2.947-.819-3.439-1.8-3.6-.164-3.6-.491,3.766-1.965,4.094-2.292,1.474-.327,2.129-.982a4.334,4.334,0,0,0,.819-2.129l.655-4.257Z\" transform=\"translate(-225.898 -321.261)\"/><path class=\"b\" d=\"M172.557,142.213a3.114,3.114,0,0,0,1.212-.277,1.623,1.623,0,0,0,.415-2.4,3.1,3.1,0,0,0-.576-.463l-1.245-.847a6.089,6.089,0,0,0-1.756-.932,5.481,5.481,0,0,0-1.8-.106,12.129,12.129,0,0,0-3.439.625,5.755,5.755,0,0,0-2.786,2.039,6.125,6.125,0,0,0-.488,5.342,18.118,18.118,0,0,0,2.769,4.8l.564-2.75a1.015,1.015,0,0,1,.319-.658c.506-.36,1.126.38,1.747.375a1.047,1.047,0,0,0,.886-.7,4,4,0,0,0,.2-1.177,3.221,3.221,0,0,1,1.167-2.48A7.384,7.384,0,0,1,172.557,142.213Z\" transform=\"translate(-146.263 -125.211)\"/><path class=\"d\" d=\"M231.2,498.653s-.553,16-.881,16.488,0-16.538,0-16.538Z\" transform=\"translate(-205.21 -436.432)\"/><path class=\"l\" d=\"M283.664,257.607h1.31s5.567,7.532,4.912,8.023,0,1.8,0,1.8l1.31,2.456s1.637,1.474,1.146,1.8a5.984,5.984,0,0,0-1.146,1.637s-3.275-.491-4.257,1.474l-2.124-2.681Z\" transform=\"translate(-251.266 -228.922)\"/><rect class=\"b\" width=\"4.863\" height=\"9.063\" transform=\"translate(28.365 32.964) rotate(-22.438)\"/><ellipse class=\"g\" cx=\"0.973\" cy=\"0.894\" rx=\"0.973\" ry=\"0.894\" transform=\"translate(30.753 34.74) rotate(-22.438)\"/><path class=\"k\" d=\"M171.552,308.257s-11.79,9.825-13.755,6.714,2.129-5.731,2.129-5.731a14.423,14.423,0,0,0,7.7-2.456l4.094-1.8s3.737-5.335,5.011-3.3S174.552,307.246,171.552,308.257Z\" transform=\"translate(-142.429 -266.472)\"/><path class=\"l\" d=\"M130.563,289.426l-1.8.655v4.912l-.655.982a6.063,6.063,0,0,0,.655,2.456c.491.491,1.474.327,1.146,1.474a6.206,6.206,0,0,0-.164,2.292s2.947,3.766,3.111,3.275,2.456-6.55,2.784-6.55-3.275-9.5-3.275-9.5Z\" transform=\"translate(-117.324 -256.319)\"/><path class=\"b\" d=\"M279.179,450.311s1.693-1.637.847-1.719-3.794-1.719-4.285-.9S279.179,450.311,279.179,450.311Z\" transform=\"translate(-244.407 -392.397)\"/><ellipse class=\"m\" cx=\"2.362\" cy=\"1.251\" rx=\"2.362\" ry=\"1.251\" transform=\"translate(64.611 24.177)\"/><path class=\"i\" d=\"M498.479,216.383a21.909,21.909,0,0,0-15.979,0v-6.531a27.656,27.656,0,0,1,15.979,0Z\" transform=\"translate(-422.475 -186.787)\"/><path class=\"i\" d=\"M510.033,219.958a15.812,15.812,0,0,0-11.533,0v-4.713a19.96,19.96,0,0,1,11.533,0Z\" transform=\"translate(-436.251 -191.713)\"/><ellipse class=\"i\" cx=\"2.362\" cy=\"1.251\" rx=\"2.362\" ry=\"1.251\" transform=\"translate(65.444 23.621)\"/><ellipse class=\"m\" cx=\"2.362\" cy=\"1.251\" rx=\"2.362\" ry=\"1.251\" transform=\"matrix(0.98, -0.2, 0.2, 0.98, 65.895, 32.532)\"/><path class=\"i\" d=\"M507.773,266.729a21.909,21.909,0,0,0-15.656,3.2l-1.306-6.4a27.656,27.656,0,0,1,15.656-3.2Z\" transform=\"translate(-429.63 -231.166)\"/><path class=\"i\" d=\"M519.4,271.639a15.812,15.812,0,0,0-11.3,2.306l-.943-4.618a19.96,19.96,0,0,1,11.3-2.306Z\" transform=\"translate(-443.707 -236.955)\"/><ellipse class=\"i\" cx=\"2.362\" cy=\"1.251\" rx=\"2.362\" ry=\"1.251\" transform=\"matrix(0.98, -0.2, 0.2, 0.98, 66.601, 31.82)\"/><ellipse class=\"m\" cx=\"1.251\" cy=\"2.362\" rx=\"1.251\" ry=\"2.362\" transform=\"translate(65.527 42.14) rotate(-86.019)\"/><path class=\"i\" d=\"M503.653,329.573a21.909,21.909,0,0,0-15.94-1.109l.453-6.515a27.656,27.656,0,0,1,15.94,1.109Z\" transform=\"translate(-426.963 -283.73)\"/><path class=\"i\" d=\"M515.854,333.1a15.812,15.812,0,0,0-11.5-.8l.327-4.7a19.96,19.96,0,0,1,11.5.8Z\" transform=\"translate(-441.288 -288.759)\"/><ellipse class=\"i\" cx=\"1.251\" cy=\"2.362\" rx=\"1.251\" ry=\"2.362\" transform=\"translate(66.397 41.644) rotate(-86.019)\"/><path class=\"i\" d=\"M356.945,263.9s-10.212-1.4-17.5,2.877\" transform=\"translate(-299.292 -234.151)\"/><path class=\"j\" d=\"M287.581,224.459l.265.084-.415,1.306,1.333.318-.065.271-1.623-.388Z\" transform=\"translate(-247.188 -193.271)\"/></svg>\n        </div>\n        <p class=\"lm-text\">Your unique invitation link</p>\n        <div style=\"display: flex;\">\n          <button class=\"lm-btn lm-copy-btn\" id=\"lm_copy_button\" type=\"button\">Copy</button>\n          <input class=\"lm-link truncate\" id=\"lm_link\" type=\"text\" value=\"" + link + "\" disabled>\n        </div>\n      </div>\n\n      <div class=\"lm-start-btn\" id=\"lm_referral_btn\"  aria-haspopup=\"dialog\" aria-label=\"Open the Message Area\" >\n        Refer a Friend\n      </div>\n    </div>\n\n    <style>\n      .lm-referral-container {\n        position: fixed;\n        bottom: 10px;\n        left: 10px;\n        font-size: 14px;\n        color: #5D61E2;\n        font-family: Arial, Helvetica, sans-serif;\n        z-index: 9999;\n      }\n\n      .lm-start-btn {\n        display: inline-block;\n        padding: 15px 20px;\n        border-radius: 3px;\n        background: #5D61E2;\n        color: #fff;\n        cursor: pointer;\n      }\n\n      .lm-start-btn:hover {\n        background: #6d5de2;\n      }\n\n      .lm-referral-body {\n        opacity: 0;\n        position: relative;\n        bottom: 15px;\n        background: #fff;\n        padding: 35px 30px;\n        width: 320px;\n        box-shadow: 0px 3px 6px #d0d0d0;\n        border-radius: 3px;\n        transform: translate3d(0,-10px,0);\n        transition: all .15s ease-in-out;\n      }\n\n      .lm-referral-body.open {\n        opacity: 1;\n        transform: translate3d(0,0,0);\n      }\n\n      .lm-heading {\n        font-size: 22px;\n        margin-top: 0;\n        text-align: center;\n        color: #5D61E2;\n      }\n\n      .lm-offer {\n        font-size: 14px;\n        font-weight: 200;\n        line-height: 1.5;\n        margin-bottom: 15px;\n        text-align: center;\n        color: #5D61E2;\n      }\n\n      .lm-text {\n        color: #5D61E2;\n      }\n\n      .lm-img-container {\n        width: 50%;\n        margin: 30px auto;\n      }\n\n      .lm-link  {\n        width: 80%;\n        border-left: 0px !important;\n      }\n\n      .lm-copy-btn {\n        width: 20%;\n        cursor: pointer;\n      }\n\n      .lm-copy-btn:hover {\n        background: #5D61E2;\n        color: #fff;\n      }\n\n      .lm-copy-btn, .lm-link {\n        border: solid 1px #5D61E2;\n        font-size: 12px;\n        color: #5D61E2;\n        padding: 10px 10px;\n        box-sizing: border-box;\n      }\n    </style>\n  ";
    var element = document.getElementById('linkmink_element');
    element ? element.insertAdjacentHTML('beforeend', referralHtml) : console.error('There is no element with id linkmink_element');
    var btn = document.getElementById('lm_referral_btn');
    btn ? btn.addEventListener('click', function (e) { return toggle(e); }) : console.error('The button isn\'t in the dom. Contact support at support@linkmink.com');
    var copyBtn = document.getElementById('lm_copy_button');
    copyBtn ? copyBtn.addEventListener('click', function () { copyToClipboard(link, copyBtn); }) : console.error('The button isn\'t in the dom. Contact support at support@linkmink.com');
}; };
